<?php
/*
#  数据模型
#  php原生mysql函数方式访问Mysql数据库，主要方法：利数组方式快速插入（insert） 利用数组做连表查询（findAll find）
#  作者：℃冻番茄 qq:7279915
#  web@ye55.com  www.ye55.com (蓝叶工作室)
*/
class db{

	public $db;
	public $table;
	public $as;
	public $dbTable;
	public $field;
	public $join;
	public $where;
	public $group;
	public $order;
	public $limit;


	function __construct()
    {
		if(!$this->db=mysql_connect(c('dbHost'),c('dbUser'),c('dbPass'))){
			throw new Exception("数据库连接信息出错！");
		}
		mysql_select_db(c('dbName'),$this->db);
		mysql_query('SET NAMES utf8');
		$this->initialize();
		
    }

	function initialize()
	{
		$this->field='*';
		$this->join='';
		$this->where='';
		$this->group='';
		$this->order='';
		$this->limit='';
	}

	function query($sql)
	{
		$_SESSION['sqlstate']=microtime(true);

		if(!$rs = mysql_query($sql,$this->db)){
			throw new Exception('SQL语句出错   <b>'.$sql.'</b>');
		}
		$this->initialize();
		$this->getRunSql($sql);
		return $rs;
	}

	function lastInsertId()
	{
		return mysql_insert_id();
	}

	function table($table)
	{
		$this->table=c('dbPix').trim($table);
		$this->tas=$this->table.' as '.$table;
		$this->tCache=$this->tableCache();
		$this->dbTable=$this->table;
		$this->table.=' as '.$table;
		
		$this->as=$table;
		return $this;
	}

	function tas($as)
	{
		$tableTmp=explode(' as ',$this->table);
		$tableTmp[1]=$as;
		$this->table=implode(' as ',$tableTmp);
		$this->as=$as;
		return $this;
	}

	function join($join)
	{
		$this->join='left join '.$join;
		return $this;
	}

	function j($array)
	{
		if(!is_array($array)) throw new Exception('Join 出错 ，参数应该为非空数组！');
		$this->join='';
		foreach($array as $k=>$v){
			$j=c('dbPix').$k;
			$this->join.="left join {$j} as {$k} on {$k}.{$v[0]}={$this->as}.{$v[1]}";
		}
		return $this;
	}

	function field($field)
	{
		$this->field=$field;
		return $this;
	}

	function where($where)
	{
		$this->where=empty($where)?"":'where '.$where;
		return $this;
	}

	function group($group)
	{
		$this->group='group by '.$group;
		return $this;
	}

	function order($order)
	{
		$this->order='order by '.$order;
		return $this;
	}

	function limit($limit)
	{
		$this->limit='limit '.$limit;
		return $this;
	}
	
	function add($data)
	{
		return $this->insert($data);
	}

	function insert($data)
	{
		$fields = "";
		$values = "";
		
		foreach($data as $field=>$value)
		{
			if(in_array($field,$this->tCache['field'])){
				$fields[]= "`$field`";
				$values[]= "'$value'";
			}
		}
		$fields = implode(',',$fields);
		$values = implode(',',$values);
		$sql = "insert into {$this->dbTable} ($fields) values ($values)";
		//echo $sql;
		if($rs = $this->query($sql)){
			return $this->lastInsertId();
		}else{
			return false;
		}
		
	}

	function delete(){
		if(empty($this->where)) return false;
		$sql = "delete from {$this->dbTable} {$this->where}";
		if(!$rs =$this->query($sql)){
			return false;
		}else{
			return true;
		}
	}

	function id($id)
	{
		$this->where="where `{$this->tCache['key']}`='{$id}'";
		return $this;
	}

	function update($data)
	{
		if(empty($this->where)) return false;
		
		foreach($data as $field=>$value)
		{
			if(in_array($field,$this->tCache['field'])){
				if($value=='NULL'){
					$set[]= " `$field`=NULL ";
				}else{
					$set[]= " `$field`='$value' ";
				}
			}
		}
		$set = implode(',',$set);
		$sql = "update {$this->dbTable} set $set  {$this->where}";

		if(!$rs =$this->query($sql)){
			return false;
		}else{
			return true;
		}

	}
	
	function count($field='count(*)')
	{
		$sql="select $field from {$this->table} {$this->join} {$this->where} {$this->group} {$this->limit}";
		return @mysql_num_rows($this->query($sql)); 
	}
	
	function find()
	{
		$sql="select {$this->field} from {$this->table} {$this->join} {$this->where} {$this->group} {$this->order} limit 1";
		if($row=mysql_fetch_array($this->query($sql))){
			return $row;
		}else{
			return false;
		}
	}
	
	function findAll()
	{
		$sql="select {$this->field} from {$this->table} {$this->join} {$this->where} {$this->group} {$this->order} {$this->limit}";
		$row=array();
		$rs=$this->query($sql);
		while($tmp=mysql_fetch_array($rs)){
			$row[]=$tmp;
		}
		if(!empty($row)){
			return $row;
		}else{
			return false;
		}
	}

	private function getRunSql($sql)
	{
		$_SESSION['run']['sql'][]=array('sql'=>$sql,'time'=>number_format(microtime(true)-$_SESSION['sqlstate'],6));
		unset($_SESSION['sqlstate']);
	}

	private function tableCache()
	{
		$name='table_'.str_replace('`','',$this->table);
		
		if(strpos($this->table,' as ')!==false){
			return false;
		}else{
			
			if(!$tCache=cache($name)){
				$rs=$this->query("describe ".$this->table);
				$tmp=array();
				while($row=mysql_fetch_array($rs)){
					if($row['Key']=='PRI') $key=$row['Field'];
					$tmp[]=$row['Field'];
				}
				$s=c('tableCacheTime');
				if(!$tCache=cache($name,array('key'=>$key,'field'=>$tmp),empty($s)?0:$s)){
					throw new Exception('表[ '.str_replace('`','',$this->table).' ] 字段缓存失败！');
				}
			}
			return $tCache;
		}
	}
  
	function __destruct()
	{
		$this->db=null;	
	}

}
//fetch('PDO_FETCH_ASSOC')
?>
